# ShowPS.py
""" Illustrates the perfect shuffle permutation
and examines how many are required before
returning to the original list.
"""

def PS(x):
    """ Perfect shuffles the values in x
    
    PreC: x is a list of ints with even length
    """
    xFirst = []
    xSecond = []
    m = len(x)/2
    for k in range(m):
        xFirst.append(x[k])
        xSecond.append(x[k+m])
    for k in range(m):
        x[2*k]   = xFirst[k]
        x[2*k+1] = xSecond[k]
        
def numPS(n):
    """ Returns an int that is the number of perfect shuffles that
    have to be applied to a length-n list of distinct integers in
    order for it to be restored to its original form.

    PreC: n is an even int.
    """
    
    a = [i for i in range(n)]
    b = list(a)
    PS(a)
    k = 1
    while a!=b:
        PS(a)
        k+=1
    return k
    
if __name__ == '__main__':
    n = input('Enter an even integer: ')
    print '\nnumPS(%1d) = %1d' % (n,numPS(n))
    if n<=20:
        a = [i for i in range(10,10+n)]
        print '\na ='
        print a
        PS(a)
        print '\nPS(a) ='
        print a
 
 
    
    

